/* -----------------------------------------------------------------------------
 *
 * Giada - Your Hardcore Loopmachine
 *
 * -----------------------------------------------------------------------------
 *
 * Copyright (C) 2010-2017 Giovanni A. Zuliani | Monocasual
 *
 * This file is part of Giada - Your Hardcore Loopmachine.
 *
 * Giada - Your Hardcore Loopmachine is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation, either
 * version 3 of the License, or (at your option) any later version.
 *
 * Giada - Your Hardcore Loopmachine is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Giada - Your Hardcore Loopmachine. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * -------------------------------------------------------------------------- */



#ifndef GE_PIANO_ITEM_H
#define GE_PIANO_ITEM_H


#include "../../../core/recorder.h"
#include "basePianoItem.h"


class gdActionEditor;


class gePianoItem : public geBasePianoItem
{
private:

	

	int getRelY();
	int getRelX();

	

	int getNote(int rel_y);

	

	bool overlap();

	struct giada::m::recorder::action *a;
	struct giada::m::recorder::action *b;

	int  push_x;

	 

	int  note;
	int  frame_a;
	int  frame_b;

	

	int event_a;
	int event_b;

	

	bool changed;

	

	bool onLeftEdge;
	bool onRightEdge;

	

	int old_x, old_w;

public:

	static const int MIN_WIDTH    = 10;
	static const int HANDLE_WIDTH = 5;

	

	gePianoItem(int x, int y, int rel_x, int rel_y, 
		struct giada::m::recorder::action *a, struct giada::m::recorder::action *b, 
		gdActionEditor *pParent);

	void draw() override;
	int handle(int e) override;

  void reposition(int pianoRollX) override;

	void record();
	void remove();
};


#endif
